/*

reinhard@finalmedia.de
20180302

*/
(function(){

    var s = window.location.search.substring(1).split('&');

    if(!s.length) return;

    window.$_GET = {};

    for(var i  = 0; i < s.length; i++) {

        var parts = s[i].split('=');

        window.$_GET[unescape(parts[0])] = unescape(parts[1]);

    }

}());


osm=L.tileLayer('tiles/osm/{z}/{x}/{y}.png', {
    attribution: 'openstreetmap.org | map powered <a href="http://osm.org">OpenStreetMap</a> contributors',
    minZoom: 13,
    maxZoom: 19,
    reuseTiles: true,
    unloadInvisibleTiles: true,
    zoomControl: true
});

demo=L.tileLayer('tiles/demo/{z}/{x}/{y}.png', {
    attribution: 'demo Layer | reinhard@finalmedia.de',
    minZoom: 13,
    maxZoom: 22,
    reuseTiles: true,
    unloadInvisibleTiles: false,
    zoomControl: true
});

var baseMaps = {
    "osm":osm,
    "demo":demo,
};


var overlayMaps = {
};


var map = new L.map('map', {
    center: [49.46693,7.16537],
    zoom: 17,
    crs: L.CRS.EPSG3857,
    zoomControl: true,
    layers: [osm]
});




mypos=$_GET['pos'];
if (mypos=="" || mypos==undefined) { mypos=$_GET['s']; }


if (mypos!="" && mypos!=undefined) {
mypos=mypos.split(",");
map.panTo([mypos[0], mypos[1]]);
L.marker([mypos[0], mypos[1]],
{title:"Markierung",clickable:true,draggable:false,
icon:L.icon({iconUrl:'images/marker.gif',iconSize:[33,33]})}
).addTo(map);
}

myzoom=$_GET['z'];
if (myzoom!="" && myzoom!=undefined) {
map.setZoom(myzoom);
}

mylayer=$_GET['layer'];
if (mylayer!="" && mylayer!=undefined) {
if (mylayer=="demo") { demo.addTo(map); }
}


map.addEventListener('dblclick', function(ev) {
    window.prompt("Koordinaten an gewählter Position:",ev.latlng.lat+','+ev.latlng.lng);
});

L.control.mousePosition().addTo(map);


function loadJSON(path, success, error)
{
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function()
    {
        if (xhr.readyState === XMLHttpRequest.DONE) {
            if (xhr.status === 200) {
                if (success)
                    success(xhr.responseText);
            } else {
                if (error)
                    error(xhr);
            }
        }
    };
    xhr.open("GET", path, true);
    xhr.send();
}


function showCameraview() {
console.log(this.getAttribute('data-poi'));
}

function compare_groupids(a,b) {
  if (a.groupid < b.groupid)
     return -1;
  if (a.groupid > b.groupid)
    return 1;
  return 0;
}




var url = "pois.csv";

var groupnames=new Array();
groupnames[0]="Schiffe";
groupnames[1]="Sonstiges";

loadJSON(url,function(data) {

var markers=new Array();
var objects_by_group=new Array();
var objectmarkers=new Array();
pois=data.split("\n");

for(p in pois) {
	if (p<pois.length-1) {
       col=pois[p].split(",");

	// nur auswerten, wenn keine commentline, also wenn die zeile nicht mit einer raute beginnt
	// sowie nur fortfahren, wenn auch mindestens drei spalten
      if(col[0].charAt(0)!="#" && col.length>3) {

       group=col[0];
       name=col[1];

	comment=name;

	filename=name;
	thumb='images/group'+group+'.png';
	markericon='images/marker'+group+'.png';

	groupid=parseInt(col[0]);
	coords=[parseFloat(col[2]),parseFloat(col[3])];
	comment=col[4];
	if (comment==undefined) { comment=""; }
	url=col[5];
	if (url==undefined) { url="#"; }

	objects_by_group.push({groupid:groupid, filename:filename, comment:comment, lng:parseFloat(col[2]), lat:parseFloat(col[3]), marker:L.marker(coords, {icon: L.icon({iconUrl:markericon,iconSize: [10,10], iconAnchor: [5, 5],popupAnchor: [0, -10]})}).bindPopup("<b>"+name+"</b><br>"+comment+"<br><br><a href='"+url+"'><img src='"+thumb+"'></a><span class='poidata' data-poi='"+col.join(",")+"'></span>")});

}}}
	objects_by_group.sort(compare_groupids);
	groupid=0;
	groups=new Array();
	markers=new Array();
	for (var f in objects_by_group) {
		a=objects_by_group[f];


		if (a.groupid>groupid && markers.length>0) {
			//groups["Gruppe "+groupid]=L.layerGroup(markers);
			groups[groupnames[groupid]]=L.layerGroup(markers);

			markers = new Array();   // leeren
			groupid=a.groupid;
			markers.push(a.marker);
		}

		groupid=a.groupid;
		markers.push(a.marker);
	}


	if (markers.length>0) {
			//groups["Gruppe "+groupid]=L.layerGroup(markers);
			groups[groupnames[groupid]]=L.layerGroup(markers);
	}

	L.control.layers(baseMaps, groups).addTo(map);


},function(xhr) { console.err(xhr);

L.control.layers(baseMaps, overlayMaps).addTo(map);



});




var blickrichtung={};

map.on('popupopen', function(e) {
   poi=e.popup._content.split("data-poi='")[1].split("'")[0].split(",");
   if (poi.length>5) { /* Blickrichtungsangabe vorhanden */
	blickrichtung=L.polyline([[parseFloat(poi[1]),parseFloat(poi[2])],[parseFloat(poi[3]),parseFloat(poi[4])],[parseFloat(poi[5]),parseFloat(poi[6])],[parseFloat(poi[1]),parseFloat(poi[2])]], {fillcolor: 'red', fill: true}).addTo(map);
   }
//   console.log(e.popup._source._icon.attributes['src']);
});

map.on('popupclose', function(e) {
	if (typeof(blickrichtung) === 'object') { map.removeLayer(blickrichtung); }
});



